// offscrnView.cpp : COffscrnView NX̓̒`s܂B
//

#include "stdafx.h"
#include "offscrn.h"

#include "offscrnDoc.h"
#include "offscrnView.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include "GL/glext.h"
#include "GL/wglext.h"

//
// OpenGL 1.2 ȏ
//
// OpenGL Extentions:
//  WGL_ARB_pbuffer
//  WGL_ARB_pixel_format
//

PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB = NULL;
PFNWGLGETEXTENSIONSSTRINGEXTPROC wglGetExtensionsStringEXT = NULL;

PFNWGLGETPIXELFORMATATTRIBIVARBPROC wglGetPixelFormatAttribivARB = NULL;
PFNWGLGETPIXELFORMATATTRIBIVEXTPROC wglGetPixelFormatAttribivEXT = NULL;

PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB = NULL;
PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB = NULL;
PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB = NULL;
PFNWGLDESTROYPBUFFERARBPROC wglDestroyPbufferARB = NULL;
PFNWGLQUERYPBUFFERARBPROC wglQueryPbufferARB = NULL;

PFNWGLCREATEPBUFFEREXTPROC wglCreatePbufferEXT = NULL;
PFNWGLGETPBUFFERDCEXTPROC wglGetPbufferDCEXT = NULL;
PFNWGLRELEASEPBUFFERDCEXTPROC wglReleasePbufferDCEXT = NULL;
PFNWGLDESTROYPBUFFEREXTPROC wglDestroyPbufferEXT = NULL;
PFNWGLQUERYPBUFFEREXTPROC wglQueryPbufferEXT = NULL;

#include <math.h>

#ifndef	M_PI
#	define	M_PI	3.1415926
#endif	/* M_PI */

static bool extensionSupported(const char *extensions, const char *extension);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COffscrnView

IMPLEMENT_DYNCREATE(COffscrnView, CView)

BEGIN_MESSAGE_MAP(COffscrnView, CView)
	//{{AFX_MSG_MAP(COffscrnView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̍\z/

COffscrnView::COffscrnView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

	m_flag_pbufferARB = false;

	m_hDC = NULL;
	m_hPbufferARB = NULL;
	m_hPbufferEXT = NULL;

	m_pbuffer_width = 0;
	m_pbuffer_height = 0;
}

COffscrnView::~COffscrnView()
{
}

BOOL COffscrnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̕`

void COffscrnView::OnDraw(CDC* pDC)
{
	COffscrnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	if (!m_hDC) {
		return;
	}

	/*
	 * pBuffer
	 */
	::wglMakeCurrent(m_hDC, m_hRC);

	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glViewport(0, 0, m_cx, m_cy);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity(); 
	::gluPerspective(45.0f, (float)m_cx / (float)m_cy, 1.0f, 2000.0f);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity(); 

	::glPushMatrix();

	::gluLookAt(
		0.0f, 0.0f, 600.0f,
		0.0f, 0.0f, 0.0f,
		0.0f, 1.0f, 0.0f
	);

	GLfloat	pos[]		= {1800.0f, 1800.0f, 2300.0f, 1.0f};
	GLfloat	col_amb[]	= {0.2f, 0.2f, 0.2f, 1.0f};
	GLfloat	col_diff[]	= {1.0f, 1.0f, 1.0f, 1.0f};
	GLfloat	col_spec[]	= {1.0f, 1.0f, 1.0f, 1.0f};

	::glLightfv(GL_LIGHT1, GL_AMBIENT, col_amb);
	::glLightfv(GL_LIGHT1, GL_DIFFUSE, col_diff);
	::glLightfv(GL_LIGHT1, GL_SPECULAR, col_spec);
	::glLightfv(GL_LIGHT1, GL_POSITION, pos);


	GLfloat	mat_ambient[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_diffuse[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_specular[] = {1.0f, 1.0f, 1.0f, 1.0f};

	::glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	::glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	::glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	::glMaterialf(GL_FRONT, GL_SHININESS, 64.0);

	::glPushMatrix();
	DrawSphere(200.0);
	::glPopMatrix();

	::glPopMatrix();
	::glFlush();

	::glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, m_cx, m_cy);
	::glFlush();

	/*
	 * Window
	 */
	::wglMakeCurrent(pDC->m_hDC, m_hRC);

	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glViewport(0, 0, m_cx, m_cy);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity(); 
	::gluOrtho2D(0.0f, m_cx / float(m_pbuffer_width), 0.0f, m_cy / float(m_pbuffer_height));
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity(); 

	::glEnable(GL_TEXTURE_2D);

	::glColor3f(1.0f, 1.0f, 1.0f);
	::glBegin(GL_POLYGON);
	::glTexCoord2f(0.0f, 0.0f);
	::glVertex2f(0.0f, 0.0f);
	::glTexCoord2f(1.0f, 0.0f);
	::glVertex2f(1.0f, 0.0f);
	::glTexCoord2f(1.0f, 1.0f);
	::glVertex2f(1.0f, 1.0f);
	::glTexCoord2f(0.0f, 1.0f);
	::glVertex2f(0.0f, 1.0f);
	::glEnd();

	::glDisable(GL_TEXTURE_2D);
	
	::glFlush();

	::wglMakeCurrent(NULL, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̐ff

#ifdef _DEBUG
void COffscrnView::AssertValid() const
{
	CView::AssertValid();
}

void COffscrnView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COffscrnDoc* COffscrnView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COffscrnDoc)));
	return (COffscrnDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̃bZ[W nh

int COffscrnView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),  //  size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // WINDOW w肷邱
		PFD_SUPPORT_OPENGL,    // support OpenGL 
		PFD_TYPE_RGBA,         // RGBA type 
		24,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		32,                    // 32-bit z-buffer     
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 

	CClientDC	dc(this);

	int	iPixelFormat = ::ChoosePixelFormat(dc.m_hDC, &pfd);
	BOOL success = ::SetPixelFormat(dc.m_hDC, iPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(dc.m_hDC);

	/*
	 * Window
	 */
	::wglMakeCurrent(dc.m_hDC, m_hRC);

	const char* version;
	int majorVersion, minorVersion;
	
	version = (const char*)::glGetString(GL_VERSION);
	sscanf(version, "%1d.%1d", &majorVersion, &minorVersion);

	const char* ext = (const char *)::glGetString(GL_EXTENSIONS);
//	AfxMessageBox(ext);

	wglGetExtensionsStringARB = (PFNWGLGETEXTENSIONSSTRINGARBPROC)::wglGetProcAddress("wglGetExtensionsStringARB");
	const char* wext = (const char *)::wglGetExtensionsStringARB(::wglGetCurrentDC());
//	AfxMessageBox(::wglGetExtensionsStringARB(::wglGetCurrentDC()));

	wglGetExtensionsStringEXT = (PFNWGLGETEXTENSIONSSTRINGEXTPROC)::wglGetProcAddress("wglGetExtensionsStringEXT");
	if (!wext) {
		wext = (const char *)::wglGetExtensionsStringEXT();
	}
//	AfxMessageBox(::wglGetExtensionsStringEXT());


	// CLAMP_TO_EDGE OpenGL 1.2 ȏŕKv
	if (majorVersion >= 2 || (majorVersion == 1 && minorVersion >= 2)) {
		//
	} else {
		MessageBox(_T("CLAMP_TO_EDGE: OpenGL 1.2 ȏオKvłB"), _T("G["), MB_ICONERROR);
		::wglMakeCurrent(NULL, NULL);
		return -1;
	}

	// WGL_ARB_pbuffer
	if (!extensionSupported(ext, "WGL_ARB_pbuffer") || !extensionSupported(wext, "WGL_ARB_pbuffer")) {
		m_flag_pbufferARB = TRUE;
	} else if (!extensionSupported(ext, "WGL_EXT_pbuffer") || !extensionSupported(wext, "WGL_EXT_pbuffer")) {
		m_flag_pbufferARB = FALSE;
	} else {
		MessageBox(_T("pBuffer T|[gĂ܂B"), _T("G["), MB_ICONERROR);
		::wglMakeCurrent(NULL, NULL);
		return -1;		
	}

	// WGL_ARB_pixel_format
	if (!extensionSupported(ext, "WGL_ARB_pixel_format") || !extensionSupported(wext, "WGL_ARB_pixel_format")) {
	} else if (!extensionSupported(ext, "WGL_EXT_pixel_format") || !extensionSupported(wext, "WGL_EXT_pixel_format")) {
	} else {
		MessageBox(_T("pixel_format T|[gĂ܂B"), _T("G["), MB_ICONERROR);
		::wglMakeCurrent(NULL, NULL);
		return -1;		
	}

	wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)::wglGetProcAddress("wglCreatePbufferARB");
	wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)::wglGetProcAddress("wglGetPbufferDCARB");
	wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)::wglGetProcAddress("wglReleasePbufferDCARB");
	wglDestroyPbufferARB = (PFNWGLDESTROYPBUFFERARBPROC)::wglGetProcAddress("wglDestroyPbufferARB");
	wglQueryPbufferARB = (PFNWGLQUERYPBUFFERARBPROC)::wglGetProcAddress("wglQueryPbufferARB");

	wglCreatePbufferEXT = (PFNWGLCREATEPBUFFEREXTPROC)::wglGetProcAddress("wglCreatePbufferEXT");
	wglGetPbufferDCEXT = (PFNWGLGETPBUFFERDCEXTPROC)::wglGetProcAddress("wglGetPbufferDCEXT");
	wglReleasePbufferDCEXT = (PFNWGLRELEASEPBUFFERDCEXTPROC)::wglGetProcAddress("wglReleasePbufferDCEXT");
	wglDestroyPbufferEXT = (PFNWGLDESTROYPBUFFEREXTPROC)::wglGetProcAddress("wglDestroyPbufferEXT");
	wglQueryPbufferEXT = (PFNWGLQUERYPBUFFEREXTPROC)::wglGetProcAddress("wglQueryPbufferEXT");

	wglGetPixelFormatAttribivARB = (PFNWGLGETPIXELFORMATATTRIBIVARBPROC)::wglGetProcAddress("wglGetPixelFormatAttribivARB");
	wglGetPixelFormatAttribivEXT = (PFNWGLGETPIXELFORMATATTRIBIVEXTPROC)::wglGetProcAddress("wglGetPixelFormatAttribivEXT");

	if (m_flag_pbufferARB) {
		int iAttributes[] = {
			WGL_MAX_PBUFFER_WIDTH_ARB, WGL_MAX_PBUFFER_HEIGHT_ARB,
			WGL_MAX_PBUFFER_PIXELS_ARB
		};
		int iValues[3];

		if (wglGetPixelFormatAttribivARB) {
			::wglGetPixelFormatAttribivARB(::wglGetCurrentDC(), ::GetPixelFormat(::wglGetCurrentDC()), 0, 3, iAttributes, iValues);
		} else {
			::wglGetPixelFormatAttribivEXT(::wglGetCurrentDC(), ::GetPixelFormat(::wglGetCurrentDC()), 0, 3, iAttributes, iValues);
		}

		m_pbuffer_width = iValues[0];
		m_pbuffer_height = iValues[1];

		CString msg;
		msg.Format("WGL_MAX_PBUFFER_WIDTH_ARB  : %d\r\nWGL_MAX_PBUFFER_HEIGHT_ARB : %d\r\nWGL_MAX_PBUFFER_PIXELS_ARB %d", 
			iValues[0], iValues[1], iValues[2]);
//		AfxMessageBox(msg);

		int iAttribList[] = {
			0
		};

		if (!(m_hPbufferARB = ::wglCreatePbufferARB(dc.m_hDC, iPixelFormat, m_pbuffer_width, m_pbuffer_height, iAttribList))) {
			AfxMessageBox("wglCreatePbufferARB()");
			return -1;
		}

		m_hDC = ::wglGetPbufferDCARB(m_hPbufferARB);

		::wglQueryPbufferARB(m_hPbufferARB, WGL_PBUFFER_WIDTH_ARB, &m_pbuffer_width);
		::wglQueryPbufferARB(m_hPbufferARB, WGL_PBUFFER_HEIGHT_ARB, &m_pbuffer_height);

		msg.Format("%d %d", m_pbuffer_width, m_pbuffer_height);
//		AfxMessageBox(msg);

	} else if (wglGetPixelFormatAttribivEXT) {
		int iAttributes[] = {
			WGL_MAX_PBUFFER_WIDTH_EXT, WGL_MAX_PBUFFER_HEIGHT_EXT,
			WGL_MAX_PBUFFER_PIXELS_EXT
		};
		int iValues[3];

		if (wglGetPixelFormatAttribivARB) {
			::wglGetPixelFormatAttribivARB(::wglGetCurrentDC(), ::GetPixelFormat(::wglGetCurrentDC()), 0, 3, iAttributes, iValues);
		} else {
			::wglGetPixelFormatAttribivEXT(::wglGetCurrentDC(), ::GetPixelFormat(::wglGetCurrentDC()), 0, 3, iAttributes, iValues);
		}
		
		m_pbuffer_width = iValues[0];
		m_pbuffer_height = iValues[1];

		CString msg;
		msg.Format("WGL_MAX_PBUFFER_WIDTH_EXT  : %d\r\nWGL_MAX_PBUFFER_HEIGHT_EXT : %d\r\nWGL_MAX_PBUFFER_PIXELS_EXT %d", 
			iValues[0], iValues[1], iValues[2]);
//		AfxMessageBox(msg);

		int iAttribList[] = {
			0
		};

		if (!(m_hPbufferEXT = ::wglCreatePbufferEXT(dc.m_hDC, iPixelFormat, m_pbuffer_width, m_pbuffer_height, iAttribList))) {
			AfxMessageBox("wglCreatePbufferEXT()");
			return -1;
		}

		m_hDC = ::wglGetPbufferDCEXT(m_hPbufferEXT);

		::wglQueryPbufferEXT(m_hPbufferEXT, WGL_PBUFFER_WIDTH_EXT, &m_pbuffer_width);
		::wglQueryPbufferEXT(m_hPbufferEXT, WGL_PBUFFER_HEIGHT_EXT, &m_pbuffer_height);

		msg.Format("%d %d", m_pbuffer_width, m_pbuffer_height);
//		AfxMessageBox(msg);
	} 

	/*
	 * pBuffer
	 */
	::wglMakeCurrent(m_hDC, m_hRC);

	// ݒ
	InitOGL();

	::wglMakeCurrent(NULL, NULL);

	/*
	 * Window
	 */
	::wglMakeCurrent(dc.m_hDC, m_hRC);
	
	::glPixelStorei(GL_UNPACK_ALIGNMENT, 8);
	::glPixelStorei(GL_PACK_ALIGNMENT, 8);
	::glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, m_pbuffer_width, m_pbuffer_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);

	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	::glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	::wglMakeCurrent(NULL, NULL);

	return 0;
}

void COffscrnView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (cx <= 0 || cy <= 0) {
		return;
	}

	/*  */
	m_cx = cx;
	m_cy = cy;
}

void COffscrnView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (m_hPbufferARB) {
		if (m_hDC) {
			::wglReleasePbufferDCARB(m_hPbufferARB, m_hDC);
			m_hDC = NULL;
		}
		::wglDestroyPbufferARB(m_hPbufferARB);
		m_hPbufferARB = NULL;
	}

	if (m_hPbufferEXT) {
		if (m_hDC) {
			::wglReleasePbufferDCEXT(m_hPbufferEXT, m_hDC);
			m_hDC = NULL;
		}
		::wglDestroyPbufferEXT(m_hPbufferEXT);
		m_hPbufferEXT = NULL;
	}

	if (m_hRC) {
		::wglDeleteContext(m_hRC);
		m_hRC = NULL;
	}
}

BOOL COffscrnView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
//	return CView::OnEraseBkgnd(pDC);

	return TRUE;
}

void COffscrnView::InitOGL(void)
{
	::glClearColor(0.68f, 0.68f, 0.68f, 1.0f);

	::glShadeModel(GL_SMOOTH);

	::glEnable(GL_DEPTH_TEST);
	::glEnable(GL_CULL_FACE);
	::glEnable(GL_LIGHTING);
	::glEnable(GL_LIGHT1);

	::glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
}

void COffscrnView::DrawSphere(double radius)
{
	double	theta, pai;
	double	co, si;
	double	co2, si2;
	double	r1, r2;
	double	h1, h2;

	for(pai = -90.0; pai < 90.0; pai += 10.0) {
		r1 = cos(pai * M_PI / 180.0);
		r2 = cos((pai + 10.0) * M_PI / 180.0);
		h1 = sin(pai * M_PI / 180.0);
		h2 = sin((pai + 10.0) * M_PI / 180.0);

		for(theta = 0.0; theta < 360.0; theta += 10.0) {
			co = cos(theta * M_PI / 180.0);
			si = sin(theta * M_PI / 180.0);
			co2 = cos((theta + 10.0) * M_PI / 180.0);
			si2 = sin((theta + 10.0) * M_PI / 180.0);

			::glBegin(GL_POLYGON);
			::glNormal3f((float)(r1 * co2), (float)h1, (float)(r1 * si2));
			::glVertex3f((float)(radius * r1 * co2), (float)(radius * h1), (float)(radius * r1 * si2));
			::glNormal3f((float)(r1 * co), (float)h1, (float)(r1 * si));
			::glVertex3f((float)(radius * r1 * co), (float)(radius * h1), (float)(radius * r1 * si));
			::glNormal3f((float)(r2 * co), (float)h2, (float)(r2 * si));
			::glVertex3f((float)(radius * r2 * co), (float)(radius * h2), (float)(radius * r2 * si));
			::glNormal3f((float)(r2 * co2), (float)h2, (float)(r2 * si2));
			::glVertex3f((float)(radius * r2 * co2), (float)(radius * h2), (float)(radius * r2 * si2));
			::glEnd();
		}
	}
}

static bool extensionSupported(const char *extensions, const char *extension)
{
	if (extensions){
		char *str = (char *)extensions;
		int len = strlen(extension);
		
		while ((str = strstr(str, extension)) != NULL) {
			str += len;
			if (*str == ' ' || *str == '\0') {
				return true;
			}
		}
	}
	return false;
}